require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_IP_CONNTRACK_H)) {
    eval 'sub _IP_CONNTRACK_H () {1;}' unless defined(&_IP_CONNTRACK_H);
    eval("sub IP_CT_ESTABLISHED () { 0; }") unless defined(&IP_CT_ESTABLISHED);
    eval("sub IP_CT_RELATED () { 1; }") unless defined(&IP_CT_RELATED);
    eval("sub IP_CT_NEW () { 2; }") unless defined(&IP_CT_NEW);
    eval("sub IP_CT_IS_REPLY () { 3; }") unless defined(&IP_CT_IS_REPLY);
    eval("sub IP_CT_NUMBER () { IP_CT_IS_REPLY*2-1; }") unless defined(&IP_CT_NUMBER);
    eval("sub IPS_EXPECTED_BIT () { 0; }") unless defined(&IPS_EXPECTED_BIT);
    eval("sub IPS_EXPECTED () { (1<<IPS_EXPECTED_BIT); }") unless defined(&IPS_EXPECTED);
    eval("sub IPS_SEEN_REPLY_BIT () { 1; }") unless defined(&IPS_SEEN_REPLY_BIT);
    eval("sub IPS_SEEN_REPLY () { (1<<IPS_SEEN_REPLY_BIT); }") unless defined(&IPS_SEEN_REPLY);
    eval("sub IPS_ASSURED_BIT () { 2; }") unless defined(&IPS_ASSURED_BIT);
    eval("sub IPS_ASSURED () { (1<<IPS_ASSURED_BIT); }") unless defined(&IPS_ASSURED);
    eval("sub IPS_CONFIRMED_BIT () { 3; }") unless defined(&IPS_CONFIRMED_BIT);
    eval("sub IPS_CONFIRMED () { (1<<IPS_CONFIRMED_BIT); }") unless defined(&IPS_CONFIRMED);
    eval("sub IPS_SRC_NAT_BIT () { 4; }") unless defined(&IPS_SRC_NAT_BIT);
    eval("sub IPS_SRC_NAT () { (1<<IPS_SRC_NAT_BIT); }") unless defined(&IPS_SRC_NAT);
    eval("sub IPS_DST_NAT_BIT () { 5; }") unless defined(&IPS_DST_NAT_BIT);
    eval("sub IPS_DST_NAT () { (1<<IPS_DST_NAT_BIT); }") unless defined(&IPS_DST_NAT);
    eval("sub IPS_NAT_MASK () { (IPS_DST_NAT|IPS_SRC_NAT); }") unless defined(&IPS_NAT_MASK);
    eval("sub IPS_SEQ_ADJUST_BIT () { 6; }") unless defined(&IPS_SEQ_ADJUST_BIT);
    eval("sub IPS_SEQ_ADJUST () { (1<<IPS_SEQ_ADJUST_BIT); }") unless defined(&IPS_SEQ_ADJUST);
    eval("sub IPS_SRC_NAT_DONE_BIT () { 7; }") unless defined(&IPS_SRC_NAT_DONE_BIT);
    eval("sub IPS_SRC_NAT_DONE () { (1<<IPS_SRC_NAT_DONE_BIT); }") unless defined(&IPS_SRC_NAT_DONE);
    eval("sub IPS_DST_NAT_DONE_BIT () { 8; }") unless defined(&IPS_DST_NAT_DONE_BIT);
    eval("sub IPS_DST_NAT_DONE () { (1<<IPS_DST_NAT_DONE_BIT); }") unless defined(&IPS_DST_NAT_DONE);
    eval("sub IPS_NAT_DONE_MASK () { (IPS_DST_NAT_DONE|IPS_SRC_NAT_DONE); }") unless defined(&IPS_NAT_DONE_MASK);
    if(defined(&__KERNEL__)) {
	require 'linux/config.ph';
	require 'linux/netfilter_ipv4/ip_conntrack_tuple.ph';
	require 'linux/bitops.ph';
	require 'linux/compiler.ph';
	require 'asm/atomic.ph';
	require 'linux/netfilter_ipv4/ip_conntrack_tcp.ph';
	require 'linux/netfilter_ipv4/ip_conntrack_icmp.ph';
	require 'linux/netfilter_ipv4/ip_conntrack_sctp.ph';
	require 'linux/netfilter_ipv4/ip_conntrack_amanda.ph';
	require 'linux/netfilter_ipv4/ip_conntrack_ftp.ph';
	require 'linux/netfilter_ipv4/ip_conntrack_irc.ph';
	if(defined(&CONFIG_IP_NF_NAT_NEEDED)) {
	    require 'linux/netfilter_ipv4/ip_nat.ph';
	}
	require 'linux/types.ph';
	require 'linux/skbuff.ph';
	if(defined(&CONFIG_NETFILTER_DEBUG)) {
	    eval 'sub IP_NF_ASSERT {
	        my($x) = @_;
    		eval q( &do {  &if (!($x))  &printk(\\"NF_IP_ASSERT: %s:%i(%s)\\\\n\\",  &__FILE__,  &__LINE__,  &__FUNCTION__); }  &while(0));
	    }' unless defined(&IP_NF_ASSERT);
	} else {
	    eval 'sub IP_NF_ASSERT {
	        my($x) = @_;
    		eval q();
	    }' unless defined(&IP_NF_ASSERT);
	}
	if(defined(&CONFIG_IP_NF_CT_ACCT)) {
	}
	if(defined(&CONFIG_IP_NF_NAT_NEEDED)) {
	    if(defined( &CONFIG_IP_NF_TARGET_MASQUERADE) || defined( &CONFIG_IP_NF_TARGET_MASQUERADE_MODULE)) {
	    }
	}
	if(defined( &CONFIG_IP_NF_CONNTRACK_MARK)) {
	}
	if(defined(&CONFIG_IP_NF_NAT_NEEDED)) {
	}
	eval 'sub tuplehash_to_ctrack {
	    my($hash) = @_;
    	    eval q({  &container_of($hash, \'struct ip_conntrack\',  $tuplehash[ ($hash->{tuple}->{dst}->{dir})]); });
	}' unless defined(&tuplehash_to_ctrack);
	eval 'sub master_ct {
	    my($conntr) = @_;
    	    eval q(( ($conntr->{master})));
	}' unless defined(&master_ct);
	eval 'sub CONNTRACK_STAT_INC {
	    my($count) = @_;
    	    eval q(( &__get_cpu_var( &ip_conntrack_stat).$count++));
	}' unless defined(&CONNTRACK_STAT_INC);
	if(defined(&CONFIG_IP_NF_NAT_NEEDED)) {
	    eval 'sub ip_nat_initialized {
	        my($conntrack,$manip) = @_;
    		eval q({  &if ($manip ==  &IP_NAT_MANIP_SRC)  &test_bit( &IPS_SRC_NAT_DONE_BIT,  ($conntrack->{status}));  &test_bit( &IPS_DST_NAT_DONE_BIT,  ($conntrack->{status})); });
	    }' unless defined(&ip_nat_initialized);
	}
    }
}
1;
